= CMake for ATLAS TDAQ Software
:source-language: bash

This page documents the usage of CMake for building the ATLAS TDAQ
Software projects. This includes both the user command that replace the
familiar cmt command, as well as the TDAQ specific cmake functions that
should be used by developers.

== Getting Started.

As a developer who checks out code and maybe wants to run a partition
you should put the following into your `$HOME/.bashrc` file:

----
alias cm_setup='source /cvmfs/atlas.cern.ch/repo/sw/tdaq/tools/cmake_tdaq/bin/cm_setup.sh'
----

and then to setup a release, run
`cm_setup [-r] release [configuration]`. Examples:

----
cm_setup nightly
# or
cm_setup tdaq-11-02-01 x86_64-el9-gcc13-dbg
----

This gets you both a build and run-time environment. This should be the
default usage for developers. The default release version is the
symbolic name `prod` for the current production release. You can also
use `nightly` for the nightly builds and `dev4` for builds against LCG
nightlies (for the couraguous).

Use the `-r` option to get *only* the run-time environment, i.e. neither
the correct compiler nor cmake are in your path. Alternatively you can
just source the `setup.sh` script from the release installation area.
Here you have to set `CMTCONFIG` to choose a different configuration
beforehand

----
export CMTCONFIG=x86_64-el9-gcc13-dbg
source /cvmfs/atlas-online-nightlies.cern.ch/tdaq/nightlies/tdaq/nightly/installed/setup.sh
----

Note that all releases are build with a valid version, even nightlies.
The tag collector and release install areas are simply using symbolic
links for `nightly` etc. to make it easier for the user. Use the
`list_projects` command (see under Utilities later) to get a list of all
available projects and their possible mapping to another version.

=== Build setup only (for experts)

Note: this is only used for bootstrapping and building the TDAQ release,
so it should be irrelevant for normal developers.

To *only* use the CMake build environment of the ATLAS TDAQ software
source the following script first:

----
 source /cvmfs/atlas.cern.ch/repo/sw/tdaq/tools/cmake_tdaq/bin/setup.sh
----

If you want to use a non-standard configuration, you should pass it on
the command line, e.g.:

----
 source /cvmfs/atlas.cern.ch/repo/sw/tdaq/tools/cmake_tdaq/bin/setup.sh x86_64-el9-gcc13-dbg
----

This script only makes sure that the correct compilers are in your PATH.
When you build software you can still specify a different tag later, as
long as the compiler stays the same. This setup should probably only be
used by experts who are testing a private `cmake_tdaq` version, or the
build scripts described later that completely control their environment.

Note that although you use the latest `cmake_tdaq` scripts from CVMFS,
the `cm_setup.sh` script will always be called with a given release and
will actually source the `cmake_tdaq/bin/setup.sh` script from the
corresponding TDAQ Common release area. This is to make sure that the
build environment is the same as when the release was build. For the
special case where you want the build but *not* the run-time setup of a
given release, source `cm_setup.sh` with the `-b` option instead (this
is incompatible with `-r`). The only use case currently is building a
patch for an older release.

== Working on a Package

We consider the most common case of working on (a set of) packages as a
developer first.

First create your work area and initialize it with a `CMakeLists.txt`
file like this:

[,cmake]
----
cmake_minimum_required(VERSION 3.14.0)
project(work)
find_package(TDAQ)
include(CTest)
tdaq_work_area()
----

You should not have to touch this file again.

The first line tells cmake to require a minimum version for itself.

The `include(...)` line includes the common `TDAQ.cmake` module that
contains all the common functions that you are going to use.

The `tdaq_work_area(...)` function defines a new project and indicates
that it is a work area. It will pick up the correct project and version
from the environment set up by the `cm_setup` alias.

=== Specifying the Release and Version explicitly

You can also pass the project name and version that you want to use
explicitly, however in most cases this should not be necessary. An
example is if you compile for the `tdaq-common` project:

[,cmake]
----
cmake_minimum_required(VERSION 3.14.0)
project(work)
find_package(TDAQ)
include(CTest)
tdaq_work_area(tdaq-common 3.3.0)
----

Note that you should not use `tdaq` as the project name here if you are
compiling a package that belongs to `tdaq-common`. Use the correct
project names instead or things will not work as expected.

The `tdaq_work_area()` command can be called with an explicit project
and version as above. It also understands some symbolic release names. While
the underlying release build will always have a specific version number,
you usually don't care about it. A symbolic release is basically a set
of symbolic links for the projects and the tag collector, so that you
can use `nightly` or `tdaq-common-nightly`. You can use these names in the
`cm_setup` command and also in the CMakeLists.txt file:

[,cmake]
----
cmake_minimum_required(VERSION 3.14.0)
project(work)
find_package(TDAQ)
include(CTest)
tdaq_work_area(nightly)
----

If the nightly release version changes this might require you to remove
your build directory and re-create it from scratch.

Note that you should not mix packages from different projects in one
work area, it might not work as expected.

=== Checking out your packages

Do this as usual with git. Check out all the packages you want to work
on.

----
git clone https://.../package1.git
...
----

After `cm_setup` you also have the `getpkg` command that essentially
does the same as the git clone:

----
getpkg mypkg [ tag-or-branch ]
----

=== Initializing the build area

Now configure your build area. You can either use pure `CMake` commands,
or use the provided helper scripts that that are TDAQ specific.

You should execute this command from the top of your work area:

----
cmake_config x86_64-el9-gcc13-opt
----

If you have used the `cm_setup.sh` script you do not have to provide an
argument, instead the configuration will be taken from the environment
(the `CMTCONFIG` variable for historical reasons).

This command will create a _build area_ named after the tag, and execute
the cmake command there to initialize it. You should now have:

----
CMakeLists.txt
package1/
package2/
x86_64-el9-gcc13-opt/
----

In principle you have to execute this command only once. Even if you
make changes to your *`CMakeLists.txt`* files it will be automatically
discovered and cmake will rerun the configure step internally.

If anything goes wrong, just *`rm -rf`* the whole build area and
re-create it.

The `cmake_config` command is by now a very minimal wrapper around
`cmake` itself. See below for using `cmake` directly.

==== CMake only Configuration

You do not need the `cmake_config` command at all, as long as the
configuration tag can be determined somehow. Here is where the
configuration is looked for:

* A CMake variable called `BINARY_TAG`, e.g. defined via the `-D`
command line option.
* The `BINARY_TAG` environment variable.
* The `CMTCONFIG` environment variable.

----
cm_setup nightly
mkdir build
cd build
cmake ..
----

The last line could also be:

----
env BINARY_TAG=x86_64-el9-gcc13-dbg cmake ..
----

or

----
cmake -DBINARY_TAG=x86_64-el9-gcc13-dbg ..
----

==== Advanced Configuration

The *`cmake_config`* script supports a different mode where the build
area is completely decoupled from the source area. This is useful if the
source is e.g. in a read-only area or on AFS while you would like to
build the software on a local disk for performance reasons.

In this case you have to create the build directory yourself. The name
is irrelevant and can be whatever you want. You should *`cd`* into the
build area and execute the *`cmake_config`* command with both the binary
tag and the path to the source area

----
mkdir build
cd build
cmake_config x86_64-el9-gcc13-opt /afs/cern.ch/work/r/rhauser/public/mywork
----

You can also specify any other command line arguments meant for the
*`cmake`* command itself after *`--`*. This works for both variants:

----
cmake_config x86_64-el9-gcc13-opt -- --trace -DSOME_VARIABLE=FOO
----

Useful options include: `--trace`, `--trace-expand` to find problems
during configuration.

===== Using CCache

To enable the use of CCache pass `-D USE_CCACHE:BOOL=TRUE` as option on
the `cmake_config` command line.

----
cmake_config -c ...
----

==== Debugging Configuration Problems

The before mentioned `--trace` and `--trace-expand` options will print
out a lot of information while CMake configures. It is usually best to
re-direct std error to a file and look at it afterwards.

To print out other useful information the `tdaq_show_info()` command
takes a series of flags on what to display. Note that it shows the
definitions at the point where it is called. i.e. typically for your
package and subdirectory. You can call it multiple times, e.g. if you do
something that is supposed to change the configuration but has not the
desired effect. The flags are mostly self explanatory, `ALL` will print
everything:

* TARGETS - currently known targets
* VARIABLES - all variables currently in scope
* CACHE - all cache variables
* DEFINITIONS - all compiler definitions currently active
* OPTIONS - all compiler options currently active
* CXXFLAGS - the C++ compiler flags
* CFLAGS - the C compiler flags
* ALL - all of the above

=== Build your packages

Go to the build area and execute *`make`* with any option you like:

----
cd x86_64-el9-gcc13-opt
make -j 8
----

Fix compiler warnings and errors as usual, rinse and repeat.

Note that you can at any time create another build area and execute
*`make`* there. It will use different options if you used a different
tag:

----
cmake_config x86_64-el9-gcc13-dbg
cd x86_64-el9-gcc13-dbg
make -j 8
----

=== Differences compared to CMT build

There is only a single build area for *all* your packages in your work
area. Note that there is a subdirectory for each of your packages in the
build area. You can go there and execute *`make`*, in this case cmake
will only re-compile this package and *all other necessary packages in
your work area*. That is, if you try to recompile *`package1`*, but you
also changed something in *`package2`* on which *`package1`* depends,
*`package2`* will also be remade.

You should be able to execute binaries straight out of the build area,
an installation is not necessary, except if your program expects a
different layout than what you have in your build area.

=== Installation

Use the *`install`* target to install the packages in your work area.
Like with CMT the default installation area is in your work area called
*`installed`*.

----
make install
----

Note that the *`install`* target implies the *`all`* target, so it will
first try to remake every target. Use *`install/fast`* to avoid this:

----
make install/fast
----

After you have executed the `make install` command in your work area,
there is a `setup.sh` file in your local install area. Sourcing it will
give you the TDAQ run-time setup for the release you compiled against,
plus modifications to your environment so binaries, libraries, databases
and python modules are picked up from your local area first.

----
source ../installed/setup.sh
setup_daq ...
----

=== Other targets

*`make help`* will show you all the targets available.

*`make test`* will execute all unit tests. An alternative is to call
*`ctest -j 4`* which can also execute the tests in parallel.

*`make clean`* does the obvious.

*`make rebuild_cache`* redoes the configuration step and re-creates the
cmake cache.

=== Adding or removing packages

If you add or remove a package from an existing work area, cmake will
not automatically detect this. Instead, go to the build directory and
execute *`make rebuild_cache`*. As an alternative you can also touch the
top level *`CMakeLists.txt`* file to force a re-configuration.

=== Enabling or disabling packages from the build

Sometimes you want to have packages checked out but not include them in
the build. In the top level *`CMakeLists.txt`* file you can set the
ENABLE_PACKAGES or DISABLE_PACKAGES variable to include or exclude
certain packages.

----
set(DISABLE_PACKAGES package2)
----

These statements should be placed *before* the *`tdaq_work_area`*
declaration.

=== Submitting a tag for a build

Once you have tested, committed and tagged your package, you should make
sure to push all the changes back to gitlab, e.g. with
`git push origin master mypkg-02-03-04`. Then you can use the `tagpkg`
command as before to submit the tag to a build

----
tagpkg mypkg tdaq-11-02-01 mypkg-02-03-04
----

This command will check the gitlab server, hence it is not enough to
have your package tagged locally !

After release tdaq-08-02-00 the implementation of the tag collector has
changed from AFS based to git submodules. To submit a tag you now need
`Developer` rights on the `tdaq-cmake` (and/or `tdaq-common-cmake`)
projects in gitlab. In this case you will be allowed to push new tags to
all nightly branches, i.e. those starting with =tdaq-99-*). For any
other branch your changes will be first pushed into a private branch,
then a merge request will be created. Somebody will have to first
approve the merge request before it can proceed. You can *force* it
create a new branch by specifying the branch name after all other
arguments.

----
tagpkg mypkg tdaq-11-02-01 mypkg-02-03-04 rhauser/test/mypkg
----

In this case the merge request will be also generated, even if it is for
a nightly release.

You can modify the default commit message when you submit a new tag for
a release, as well as the titlle fo the merge request.

You can add the `--draft` option to make your merge request a draft
that can't be merged yet.

----
tagpkg --msg="Fixes ADHI-1234" --draft --title="A possible fix for ADHI-1234" mypkg tdaq-08-03-00 mypkg-02-03-04 rhauser/bugfix/ADHI-1234
----

Now you can simply push more tags into your branch, they will simply
update the existing merge request:

----
tagpkg --msg="Now really fixed !"  mypkg tdaq-11-02-01 mypkg-02-03-05 rhauser/bugfix/ADHI-1234
----

When you think your changes are ready to be merged, simply push the button
in the MR web page to remote the draft status.

=== Various utilities

The `list_projects` command will list existing installations for the
given projects. By default it will list all for `tdaq-common` and
`tdaq`. You can give a list of project names if you are interested in
only some of them.

----
list_projects tdaq-common
----

will list all tdaq-common installations.

The `list_tags` command will show you all tags for the given versioned
release. Any further arguments are given to `grep` to filter the output.

----
list_tags tdaq-11-02-01
----

shows all tags for the release.

----
list_tags tdaq-11-02-01 dqm
----

will show all tags for packages with `dqm` in their name.

----
list_tags tdaq-11-02-01 -v RCD
----

will show all tags for packages that do *not* have `RCD` in their name.

The `diff_releases` tool can be used to display changes between releases
(any two commits really) in terms of packages and tags.

----
diff_releases tdaq tdaq-11-01-00 tdaq-11-02-01
----

will display a table of packages that have changed and their respective
tags. This can take a while, so be patient. If you just want the list of
packages that are different. The third parameter defaults to `HEAD`, so
you can show any changes between a past release and now.

----
diff_releases --names-only  tdaq tdaq-11-01-00 tdaq-11-02-01
----

will be much faster.

You don't have to use offical release branches, e.g. to check what has
changed in the last 10 commits:

----
diff_releases tdaq HEAD~10
----

Note that you can go to the nightly release areas (e.g.
`pushd $TDAQ_INST_PATH/..`) and use git to show all changes including
those in submodules. This works for the `git diff` and the `git log`
commands.

----
git diff --submodule=diff HEAD~10

git log -p --submodule=diff
----

=== Advanced Build Options

While the default build system is `make`, you can choose different
generators or additional generators, e.g. for Eclipse. You can pass
these options to cmake or cmake_config. An example is to use the Ninja
build sytem. It can be installed by hand or on El9 via
`yum install -y ninja-build`.

Then you can instead use:

----
cm_setup
mkdir build
cd build
cmake -G Ninja ..
ninja-build -j 4
----

You can make any scripts independent from the build system by using
`cmake` to execute the build commands:

----
cmake --build . --target all -- -j 4
cmake --build . --target install
cmake --build . --target test
----

== Writing *`CMakeLists.txt`* files
:source-language: cmake

As you modify existing packages or create new ones, you will have to
specify what you want in a *`CMakeLists.txt`* file. This file lives in
the top level directory of your package (unlike the *`cmt/requirements`*
file). It is up to the developer if he uses a single file, or structures
his package into multiple subdirectories with their separate
*`CMakeLists.txt`* files. During the transition from CMT all packages
have been converted to use only a single top level file.

Each *`CMakeLists.txt`* file for a TDAQ package should start with the
following function call:

----
tdaq_package()
----

Please note that no package name is specified. The package name is
simply the name of the containing directory. There is neither an
*`author`* or *`manager`* attribute like for CMT. These are never
up-to-date and are best retrieved from the version control system
instead. You can, of course, specify any information you want in a
comment:

----
# Author: Reiner.Hauser@cern.ch
tdaq_package()
----

In the following we list all the TDAQ specific functions that you should
use to create targets. Do *not* use the plain cmake functions, since it
will usually lead to files that do not end up in the proper RPMs as we
expect them. In addition the TDAQ functions provide in most cases a
superset of the native cmake functionality and make many things easier
that doing them by hand.

All TDAQ specific functions are prefixed with *`tdaq_`* and should not
conflict with either cmake or ATLAS offline functions.

=== Available TDAQ specific variables

The following information is available in the specified cmake variables
inside a package:

* TDAQ_PROJECT_NAME - The name of the project and its version number in
the TDAQ standard format, e.g. tdaq-06-02-00.
* TDAQ_PACKAGE_NAME - The name of the current package.
* TDAQ_PACKAGE_VERSION - The version of the current package. Can be
*`HEAD`* or *`UNKNOWN`*.

=== Include conventions

Like for CMT the convention that public include files are in a directory
named after the package is directly supported. There is no need to do
anything special if the directory exists.

In addition the header files from the subdirectory are automatically
installed. In case this is not wanted the *`NO_HEADERS`* flag can be
given to the *`tdaq_package`* command:

----
tdaq_package(NO_HEADERS)
----

In this case headers have to be installed by hand via the
*`tdaq_add_header_directory()`* command if desired.

=== Building a library

The *`tdaq_add_library()`* function is used to create a library. By
default shared libraries are created. Note that source files are
specified with a path from the top level of the package, not relative to
the *`src`* directory as in CMT.

A simple example:

----
tdaq_add_library(mylib src/File1.cxx src/File2.cxx)
----

The functions supports wildcards for source files. Note that the cmake
developers recommend against using them and don't support them in the
native *`add_library()`* function, but since many developers are used to
this from CMT, it is supported in the TDAQ wrapper.

----
tdaq_add_library(mylib src/*.cxx)
----

Libraries and executables are automatically installed. In case you do
*not* want to install it, specify the NOINSTALL option. This is more
commonly used with test executables than libraries.

----
tdaq_add_library(mylib NOINSTALL src/*.cxx)
----

Although the default is to build a shared library, you can specify any
of the other cmake types for a library instead:
*`SHARED, STATIC, MODULE, OBJECTS, INTERFACE`*. In addition you can
specify *`DAL`* which will build a shared library. The type indicates
that this library is created from OKS generated files and some
additional magic happens to make the generated header files
automatically available to any users of the library. *`MODULE`*
indicates also a shared library, but typically for a plug-in that is
loaded at run-time.

----
tdaq_add_library(mylib STATIC src/*.cxx)
----

A library may depend on other libraries. In this case specify those in
the LINK_LIBARIES argument (without the *`lib`* prefix and with the
*`.so`* suffix): Note that cmake is free form and requires not end of
line continuation. There is a cmake mode for emacs for easier
formatting.

----
tdaq_add_library(mylib
    src/*.cxx
    LINK_LIBRARIES otherlib1 otherlib2)
----

For simple libraries the previous call is identical to:

----
tdaq_add_library(mylib src/*.cxx)
target_link_libraries(mylib PUBLIC otherlib1 otherlib2)
----

Like the native *`target_link_libraries`* command you can specify the
nature of the dependency with *`PUBLIC, PRIVATE`* or *`INTERFACE`*. The
default is *`PUBLIC`* and is usually the correct one to use.

As mentioned the default include directory named after the package is
automatically added to the compiler options. If you need additional
non-standard directories you can specify them with
*`INCLUDE_DIRECTORIES`*. It also supports the modifiers of the
underlying *`target_include_directories`* command. If the additional
non-standard directory will not be installed and is not to be seen by
clients, the *`PRIVATE`* option is usually the correct one:

----
tdaq_add_library(mylib src/*.cxx
    INCLUDE_DIRECTORIES PRIVATE src/implementation
    LINK_LIBRARIES otherlib1 otherlib2
----

if the library requires special preprocessor definitions or compile
options, they can also be specified as arguments. They correspond to the
underlying *`target_compile_definitions()`* and
*`target_compile_options()`* commands. Use of this option makes sure
that the definitions are propated to targets if necessary (i.e. if they
are PUBLIC). This should usually be avoided if at all possible.

----
tdaq_add_library(mylib src/*.cxx
    INCLUDE_DIRECTORIES PRIVATE src/implementation
    DEFINITIONS -DUSE_64BIT=1          # public, propagated to user of library
    OPTIONS  PRIVATE -Wall          # not propagated
    LINK_LIBRARIES otherlib1 otherlib2
----

The source files given to the command are usually C or C++ files. In
addition the command accepts CORBA IDL files. Internally the CORBA IDL
code generator is called and the resulting files are added to the source
files for the library. Since the IDL file may have dependencies on other
IDL files, they can be specified with the IDL_DEPENDS option.

----
tdaq_add_library(mylib src/*.cxx mycorba.idl
    IDL_DEPENDS ipc/ipc.idl
    LINK_LIBRARIES otherlib1 otherlib2
----

=== Building an executable

To create an executable use the *`tdaq_add_executable()`* command. The
options are a subset of the *`tdaq_add_library()`* command, so we refer
to that instead and just give an example of the all available options:

----
tdaq_add_executable(myprogram bin/*.cxx
    INCLUDE_DIRECTORIES PRIVATE myheader/details
    DEFINITIONS PRIVATE -DFAST
    OPTIONS PRIVATE -O3
    LINK_LIBRARIES mylib)
----

If you want an executable to have an entry in the OKS database, call the
`tdaq_add_to_repo()` command on the target:

----
tdaq_add_to_repo(myprogram DESCRIPTION "This is my program")
----

The `tdaq_add_to_repo()` command takes a number of additional optional
parameters:

* DESCRIPTION - a string with a short description of the program (should
just a couple words)
* URL - a link to the help for the program
* PARAMETERS - additional default parameters for the binary
* RESOURCES - needed resources for the binary
* ENVIRONMENT - needed environment variables for the binary
* USES - additional external software packages for the binary
* INCLUDES - additional non-standard OKS schema or data files needed

=== Building a jar file

The only support for Java is building a jar file. The *`tdaq_add_jar()`*
command should be used for this. The following options from the
underlying *`add_jar()`* command are available:

* SOURCES - followed by list of source files. This is not really
necessary, all remaining arguments are treated as source files.
* MANIFEST - manifest file
* OUTPUT_DIR - output directory
* OUTPUT_NAME - name of jar file if different from target name. This can
be necessary if there is already another target with the same name.
* VERSION - version
* ENTRY_POINT - entry point
* INCLUDE_JARS - required jars. These should be specified as
*`package/foo.jar`* - <span class="WYSIWYG_COLOR" style="color:
orangered;">including local package jars</span>.
* DAL - this jar contains source generated from a dal in the same
package.

Like the other TDAQ specific functions this command adds support for
wildcards for source files and IDL files:

----
tdaq_add_jar(myjar
     java/daq/*.java
     idl/mycorba.idl
     IDL_DEPENDS ipc/ipc.idl
     INCLUDE_JARS ipc/ipc.jar TDAQExtJars/external.jar
----

The *`NOINSTALL`* flag can be used to prevent installation which happens
by default.

To add the jar file to the OKS repository for the release, call
`tdaq_add_jar_to_repo()`:

----
tdaq_add_jar_to_repo(myjar)
----

Like `tdaq_add_to_repo()` it takes the additional paramters
`DESCRIPTION, URL, RESOURCES, USES`.

=== Installing Python Modules

The *`tdaq_add_python_package()`* command can be used to install a
Python module. It is assumed that the module lives under *`python/...`*.
The *`SOURCE`* option can be used to specify a different source
location.

----
tdaq_add_python_package(mypackage)
tdaq_add_python_package(otherpackage SOURCE mypythondir)
----

To install Python files that are not following the package structure,
use *`tdaq_add_python_files()`*

----
tdaq_add_python_files(python/ers.py)
----

=== Installing Scripts

An non-binary scripts can be installed with the *`tdaq_add_scripts()`*
command:

----
tdaq_add_scripts(bin/myscript python/mycommand.py)
----

To add a script to the OKS repository, call `tdaq_add_to_repo()`.

=== Installing non-standard header files

An non-standard header files should be installed with
*`tdaq_add_header_directory()`*. In its simplest form it just takes a
directory name:

----
tdaq_add_header_directory(src/include)
----

A non-standard target directory can be specified with the
*`DESTINATION`* parameter

----
tdaq_add_header_directory(src/include DESTINATION details)  # installed/include/${TDAQ_PACKAGE_NAME}/detail/
----

In addition either a list of files or one or more patterns can be
specified to restrict the files to be installed:

----
tdaq_add_header_directory(src/include PATTERN *.h *.hxx)
tdaq_add_header_directory(src/include FILES a.hpp b.hpp)
----

A subtle detail is the trailing slash / after the source directory. If
the source directory ends with a name, this last component will be part
of the installed area. If it ends in a slash, only the files inside the
source directory will be copied to the destination directory.

=== Installing data files

The *`tdaq_add_data()`* function can be used to add package specific
data files of any type. The destination is always
*`share/data/$\{TDAQ_PACKAGE_NAME}`*, but an additional path can be
specified with the *`DESTINATION`* parameter.

----
tdaq_add_data(data/mydatafile)
tdaq_add_data(data/mystuff DESTINATION subdir)  # goes to share/${TDAQ_PACKAGE_NAME}/subdir/mystuff
----

=== Installing documentation

The *`tdaq_add_docs()`* function can be used to add package specific
documentation of any type to the installation area of the release. The
destination is always *`share/doc/$\{TDAQ_PACKAGE_NAME}/DESTINATION`*,
where additional path can be specified with the *`DESTINATION`*
parameter:

----
tdaq_add_docs(doc/*.html DESTINATION html)
----

=== Installing OKS files

The *`tdaq_add_db()`* command should be used to install OKS files to the
standard *`share/data/daq/*`* hierarchy. The *`DESTINATION`* parameter
is required and should be one of the usual *`hw`*, *`sw`*,
*`partition`*, *`segments`*.

----
tdaq_add_db(data/my_hw.data.xml DESTINATION hw)
----

Both this and the following command use the `$\{TDAQ_DB_PROJECT}`
variable to determine the value to use for the `daq` part above. If you
want to change this for a project, set this variable to something else
in the top level project `CMakeLists.txt` file (see the section about
building other projects against TDAQ).

=== Installing OKS schema files

The *`tdaq_add_schema()`* should be used for the common case of
installing OKS schema files.

----
 tdaq_add_schema(schema/myschema.schema.xml schema/other.schema.xml)
----

=== Installing IS schema files.

The *`tdaq_add_is_schema()`* command should be used to install schema
files that describe IS info objects.

----
tdaq_add_is_schema(info/myinfo.schema.xml)
----

=== DAL Generation

The *`tdaq_generate_dal()`* command should be used to generate C++ and
Java code from OKS schema files. The full signature looks like this:

----
tdaq_generate_dal(schema_file...
                     NAMESPACE ns
                     [INCLUDE_DIRECTORIES ...]
                     [CLASSES ...]
                     [PACKAGE name]
                     [INCLUDE dir]
                     [NOINSTALL]
                     [CPP dir] [JAVA dir]
                     [CPP_OUTPUT var1] [JAVA_OUTPUT jvar2]
                     [DUMP_OUTPUT var2])
----

The command will generate the C++ and/or Java code and put the names of
the generated files in the variables passed in the *`CPP_OUTPUT`* and
*`JAVA_OUTPUT`* arguments respectively. Here is a simple use case:

----
  tdaq_generate_dal(data/schema/myclasses.schema.xml
      NAMESPACE MyNamespace
      INCLUDE_DIRECTORIES dal
      INCLUDE DFConfiguration
      CPP_OUTPUT dal_cpp_srcs)

  tdaq_add_library(mylib DAL ${dal_cpp_srcs})
----

This generates the C++ code for the classes in the schema file, using
the namespace *`MyNamespace`* and refering to previously declared
classes from the *`dal`* package. The header files will be installed
into *`include/DFConfiguration`*. Note that the user doesn't have to
know the names of the generated files. They are simply passed on to the
library that uses them. In a similar way, the Java sources can be
generated (typically using the *`PACKAGE`* argument to specify the
generated package name. You can also generate the C++ and Java with a
single command. The Java sources should be passed to the
*`tdaq_add_jar()`* command.

If you want to build the generated dump command for this schema, specify
the *`DUMP_OUTPUT`* variable which will contain the source file for the
dump command. You can pass that to *`tdaq_add_executable()`*.

For both C++ and Java based libraries the `DAL` option should be
specified when generated source files are used. This ensures that
certain race conditions during the generation and the usage of the files
are properly handled. The most common use case of having a single DAL
and one or more libraries/jars using it is covered in this case.

If you are in the unusual situation that you generate more than one DAL
in the same package, you have to do a bit more work: First pass the
`TARGET target_name` parameter to `tdaq_generate_dal()`. It will uses
this name instead of a default to represent the generation of the source
files. Then use the `add_dependencies()` command to explicitly add
dependencies between the DAL generation target and any consumers of the
generated files.

----
tdaq_generate_dal(TARGET dal1 schema/s1.schema.xml ...CPP_OUTPUT dal1_sources)
tdaq_generate_dal(TARGET dal2 schema/s2.schema.xml ...CPP_OUTPUT dal2_sources)

tdaq_add_library(consumer1 ${dal1_sources})
add_dependencies(consumer1 dal1)

tdaq_add_library(consumer2 ${dal2_sources})
add_dependencies(consumer2 dal2)
----

You may not encounter any problems during development at all, especially
if you don't do a highly parallel build. However, during the nightly
builds we use all the cores of the machines we are running on, and if
there are users in other packages of your library, the probability of
race conditions increases.

=== IS Info Generation

The *`tdaq_generate_isinfo()`* command should be used to generate C++
and Java code that represents objects from the Information Service. The
signature of the command looks like this:

----
tdaq_generate_isinfo(target_name
                    schema_files...
                     [CPP_OUTPUT var]
                     [JAVA_OUTPUT var]
                     [OUTPUT_DIRECTORY dir]
                     [NAMED][SIMPLE]
                     [NAMESPACE names]
                     [PACKAGE name]
                     [PREFIX dir]
                     [NO_NAMESPACE]
                     [NO_PRINT]
                     [NOINSTALL]
                     [INPUTS file1 file2...]
                     [CLASSNAME class]
                     [ARRAY] )
----

The generated files are returned in the variables passed to
*`CPP_OUTPUT`* and *`JAVA_OUTPUT`* respectively. The other options
correspond to the command line options of the *`is_generator.sh`*
command which you can see with the *`-h`* option.

The `INPUTS` options should be used if you already have a file with user
defined code that should be regenerated for the latest schema, but with
the user code preserved. The assumption is that the input files are in
your source area (under version control). They will be copied to the
build area where the generator expects them and there they will be
overwritten with the latest version.

If you want to use the generated files, you should simply add the
*`target_name`* to your *`LINK_LIBRARIES`* list. This will automatically
trigger the generation of the files and the proper usage. The files are
also generated if the source files are used by any library or executable
(despite the fact that these are header only, you can add them to the
source list of a library etc.)

Here is a simple example from the *`TTCInfo`* package:

----
tdaq_generate_isinfo(TTCInfo_ISINFO      data/ttc_is_info.xml CPP_OUTPUT cpp_srcs   SIMPLE NAMED OUTPUT_DIRECTORY TTCInfo)
----

=== ROOT Dictionary Generation

To generate a ROOT dictionary with rootcling, call the
`tdaq_root_generate_dictionary()` command.

----
tdaq_root_generate_dictionary( dictionary
                                    header1 header2 ...
                                    LINKDEF linkdef1 ...
                                    OPTIONS opt1...)
----

The `dictionary` parameter should be a simple string without extension.
The result will two generated source files, `dictionary.cpp` and
`dictionary_rdict.pcm`. You can use the cpp file as part of the source
files of another target, e.g. a library or executable. You should
install the pcm file with `tdaq_add_pcm()`. The pcm files are required
for ROOT 6 to function properly.

=== Qt4 Based Packages

For Qt4 based packages you should call the
`find_package(Qt4 REQUIRED QUIET)` after the `tdaq_package()` function.
Then you can use the facilities as described in the
https://cmake.org/cmake/help/v3.14/manual/cmake-qt.7.html[CMake Qt web
page]. Please note that the automatic code generation features described
here have never worked successfully in the TDAQ build. They make certain
assumptions about the names of the generated UI files, e.g. that are
often different for the existing code.

Two TDAQ specific wrappers exist `TDAQ_QT4_WRAP_UI` and
`TDAQ_QT4_ADD_RESOURCE`. The first almost equivalent to the
corresponding `qt4_wrap_ui` function, but allows you to define the
output name for each input name during the UI generation. You this by
defining the function `tdaq_ui_output_name` in your local package. It
takes an input name and returns the desired output name. The wrapper for
`qt4_add_resource` simply swaps some internal command line parameters to
make it possible for you to pass additional options to the resource
compiler.

Below is a fragment from the `dqm_display` package that shows the usage:

----
tdaq_package()

find_package(Qt4 REQUIRED QUIET)

tdaq_qt4_add_resources(qrc_srcs src/display/Display.qrc OPTIONS -name display_img)

macro(tdaq_ui_output_name output input)
  set(${output} ${CMAKE_CURRENT_BINARY_DIR}/${input}.h)
endmacro()

file(GLOB ui_inputs src/display/ui/*.ui)
tdaq_qt4_wrap_ui(ui_srcs ${ui_inputs})

...
----

There is another corner case: if your final executable has the same name
as your package, the MOC compiler wlll insist on creating a temporary
directory with the package name where it will put the generated files.
This will conflict with creating your final binary. See the
`dqm_display` or `dbe` package for a work-around that puts the MOC files
into a separate directory instead.

If you executable lives in a subdirectory, another option is to create a
special `CMakeLists.txt` file just for the executable in the
subdirectory and call `add_subdirectory(...)` from the top level
`CMakeLists.txt`. The resulting output file will end up in the
subdirectory in the build area.

=== Large Files [Deprecated]

Large files of any type should not be stored in git itself, especially
binary files. If they are needed at build or test time, they should be
fetched with a special function `tdaq_get_data()`. The developer should
arrange with the librarian to have the files stored in a central place.
The file will be made available at configuration time with a call to
`tdaq_get_data()`. The function takes two parameters: a relative URL and
either a file name or a directory name, depending on the type of file
that is downloaded. Compressed and uncompressed tar archives and zip
archives are automatically unpacked.

The relative URLs should be structured to allow for future evolution and
versioning. Since these files are supposed to be rather long lived and
stable, the versioning should be different from git. The easiest is to
have a part that makes it clear where the data belongs to, and a version
string, e.g.

----
tdaq_get_data(mypackage/v1/myfile.hpp output/myfile.hpp)
----

This will download the file `myfile.hpp` and put it into
`$\{CMAKE_CURRENT_BINARY_DIR}/output/myfile.hpp`.

----
tdaq_get_data(mypackage/v2/mydata.tar.gz output/mydata)
----

This will download and unpack the archive inside the
`$\{CMAKE_CURRENT_BINARY_DIR}/output/mydata` directory.

Files will not be re-downloaded if the cmake configuration is re-run.

== Unit Tests

If you have unit tests for your package, you should add them with
`add_test()` command. Ideally this tests should be mostly stand-alone
and run out of the box. Integration tests that need a partition are not
a good candidate for `add_test()` inside your package. See e.g.
https://gitlab.cern.ch/atlas-tdaq-software/eformat for a package with a
number of unit tests.

After you build your package, you can execute the tests by running
`ctest` in your build area. See the
https://cmake.org/cmake/help/v3.14/manual/ctest.1.html[CTest manual] for
more details on how to select tests etc.

The previous paragraphs assume that your unit tests are rather simple
and do not require a run-time setup. This should be the case for having
localized tests that exercise methods on your classes. For more
sophisticated tests, where you assume the environment that you have
after a `cm_setup ...`, you can make use of the `$\{TDAQ_RUNNER}`
variable. You specify your tests like this:

----
add_test(NAME mypartition COMMAND ${TDAQ_RUNNER} pm_part_hlt.py -p mypartition)
----

Note that these tests will only work *after* you have done a
`make install`. This is the case during the nightly and continuous
builds, but if you are in your work area, you have to make sure to

[,shell]
----
make install
ctest
----

You should never make any assumptions on which machine, under which user
account or with which permissions your test will execute. Most
importantly, do not assume that even a basic infrastructure is
available. You should set `TDAQ_IPC_INIT_REF` to point to a private
file. If you don't need a full infrastructure, just run =ipc_server
`. Otherwise let =setup_daq` take care of the setup. Try to kill any
remaining processes at the end. In such a case it is usually best to
package the whole test in a shell script:

[,shell]
----
#!/bin/bash
ref=$(mktemp)
export TDAQ_IPC_INIT_REF=file:${ref}
ipc_server &
ipc_pid=$!

...start other processors and tests...
...maybe capture status of last one...
ret=$?

kill -9 ${ipc_pid}
exit ${ret}
----

The default work directory of a test is the current build directory. You
can change that but don't assume e.g. that the source area is writable
to you.

=== The `tdaq_add_test()` command

This wrapper command takes the same arguments as `add_test()` plus an
optional flag `POST_INSTALL`. If the latter is given, it is assumed that
the test has to run after installation and the command is automatically
prefixed with `$\{TDAQ_RUNNER}` as described above. In addition the test
name is prefixed with the package name and an underscore. This makes it
easier to choose test names without having to take all of TDAQ into
account, and to later identify where a test was defined.

Depending on the `POST_INSTALL` flag, the test is labelled with either
`pre_install` or `post_install`. This can be used to execute them as
needed with the `ctest -L` option:

[,shell]
----
# only run pre installation tests
ctest -L pre_install

# only run post installation tests
ctest -L post_install

# Run a subset based on regular expression
ctest -L pre_install -R mypackage.*
----

== Automated Continuous Testing

While you can test your package individually while you develop, it is
cumbersome to do so for all possible configurations and releases that
are active at any given moment. You can automate this by having gitlab
execute the build and tests for you. See
https://gitlab.cern.ch/help/ci/README.md for the official gitlab
documentation and https://gitlab.cern.ch/groups/gitlabci-examples for
many exampels. The following describes a TDAQ specific setup.

To enable automated testing you should add a `.gitlab-ci.yml` file into
the top level directory of your project. You are free to add any jobs to
the file, e.g. using static code checkers taken from here:
https://gitlab.cern.ch/gitlabci-examples/static_code_analysis

If you want to automatically build your package on a set of releases,
you should add the following YAML lines to the file:

[,yaml]
----
include: 'https://gitlab.cern.ch/atlas-tdaq-software/tdaq_ci/raw/master/includes/tdaq-ci.yml'
----

If your package belongs to tdaq-common, it should instead look like
this:

[,yaml]
----
variables:
   project: tdaq-common
   RELEASE: tdaq-common-nightly

include: 'https://gitlab.cern.ch/atlas-tdaq-software/tdaq_ci/raw/master/includes/tdaq-ci.yml'
----

Other reasons to overwrite the RELEASE are if you fork a package, e.g.
to make a patch for a specific production release. Then your new branch
can explicitly build against that version.

This example will trigger a build of your package for the `nightly`
releases, in all configurations that we are currently using, whenever
you push a new commit to gitlab. The list of build configurations is
defined by the librarian since it typically changes over time, and you
shouldn't have to update your package just because we decide to try a
new compiler.

For the `releases:` variable you should use preferably only symbolic
release names: `tdaq-common-nightly`, `nightly`, etc. although it will
also understand something like `tdaq-06-02-00`. However, instead of
hard-coding the latest production release, just use `prod` instead.

Once you have pushed your changes to gitlab you should see a series of
jobs started under `Pipelines`. You can click on them to see as the jobs
are executing. At the end of the jobs the results will be posted to the
dashboard https://atlas-tdaq-sw.web.cern.ch/atlas-tdaq-sw/cdash under
the `Continuous` heading. The build name will consist of the package
name, followed by the release name and the configuration.

The full documentation is here:
https://gitlab.cern.ch/atlas-tdaq-software/tdaq_ci

=== Troubleshooting for new packages

The mechanism above depends on a few things that have to be properly
setup in each project. This has been done for all existing packages, but
you may run into it for newly created ones.

If you builds do not start, gitlab should show you some explanation,
e.g. invalid yaml file syntax. If the job cannot start because it cannot
find a runner, contact the librarians. If you select `Runners` in the
drop down menu on the right for your project, you should see a
`Specific Runner` with the `tdaq` tag next to it.

The following is no longer needed but was required by the previous
suggested setup:

<strike>The mechanism also relies on the existence of a build token and
a secure variable `TDAQ_CI_TOKEN` in each project. They have been
created automatically for all TDAQ projects in the `atlas-tdaq-software`
group. If you delete them by mistake, go to `Triggers` in the drop dow
menu and create a new one. Copy the token value, select `Variables` from
the menu and post the token into the value field. Add `TDAQ_CI_TOKEN` as
the name of the variable.</strike>

== Using targets and software from other projects

If a library is not build inside the current project, it comes from
another project. Examples are libraries from external software, like
ROOT, Boost etc. But the same holds true for libraries from the
different TDAQ projects itself. E.g. the *`ers`* library is part of
*`tdaq-common`* so it is an external library when used from *`tdaq`*.

The TDAQ wrapper functions handle all external targets in the same way:
the user has to specify them with the project name, followed by two
colons and the library name. Internally the cmake *`find_package()`*
function will be called and if it succeeds the relevant libraries and
include options are added to the compile options automagically. Here is
an example using various exernal software (from the point of view of the
main TDAQ release):

----
tdaq_add_library(mylib src/*.cxx
    LINK_LIBRARIES
       ROOT::Hist
       Boost::filesystem
       tdaq-common::ers)
----

You should always refer to targets inside the current project with just
their name. So if your package is part of *`tdaq-common`* you would just
refer to *`ers`* instead of *`tdaq-common::ers`*.

If the external software consists of just a single library (i.e. it has
no components in the CMake terminology), you can just add the name of
the corresponding `FindXYZ.cmake` module. E.g. for `CppUnit` there is a
`FindCppUnit.cmake` file and to use it you just do:

----
tdaq_add_executable(mytest ---- LINK_LIBRARIES CppUnit).
----

Note that the standard CMake modules often work by default, in some
cases they had to be fixed to pick up the LCG externals. All those files
are part of the rsp. TDAQ projects where they are first used.

Here are some examples for the commonly used externals, in most cases
the `Example Use` can just be added to `LINK_LIBRARIES`:

[cols="<,<,<",options="header",]
|===
|External Software |Example Use |Comment
|Boost |`Boost::boost` |For Boost header files only

|Boost |`Boost::thread` |For using a library from Boost

|zlib |`ZLIB` |The zlib header and library dependencies

|Intel TBB |`TBB` |Use headers and library of Intel thread building
blocks

|CppUnit |`CppUnit` |C++ unit tests headers and library

|ROOT libHist.so |`ROOT::Hist` |The libHist.so library from ROOT

|xrootd |`Xrootd` |xrootd headers and libraries

|COOL |`COOL::CoolApplication` |COOL headers and library

|CORAL |`CORAL::CoralKernel` |CORAL headers and libraries

|MySQL |`MySQL` |MySQL headers and library

|Oracle |`Oracle` |Oracle client headers and libraries

|XercesC |`XercesC` |XercesC headers and library

|SQLite |`SQLite` |SQLite headers and library
|===

For software not coming from LCG, please check the standard CMake
modules e.g. here:

https://cmake.org/cmake/help/v3.14/manual/cmake-modules.7.html

== Software Repository Generation

Each time `tdaq_add_to_repo()` or `tdaq_add_jar_to_repo()` is called, an
entry int `$\{CMAKE_BINARY_DIR}/sw_repo.yaml` is created. The format of
this file is in YAML. You can use the `create_repo.py` script to create
an OKS software repository with all your binaries, scripts and jar
files. Here is an example of how to do this:

----
# Find the tool
find_program(CREATE_REPO NAMES create_repo.py HINTS ${TDAQ_INST_PATH}/share/bin)
# Create the output directory
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/daq/sw)

# Add your sw repository to to the sw_repo.yaml file
tdaq_add_software_repository("MyRepo"
  INSTALLATIONPATH ${CMAKE_INSTALL_PREFIX}
  INSTALLATIONPATHVARIABLENAME MYREPO_INST_PATH
  USES "Online" )

add_custom_command(OUTPUT daq/sw/myrepository.data.xml
   COMMAND ${CREATE_REPO} "MyRepo" daq/sw/myrepository.data.xml ${CMAKE_BINARY_DIR}/sw_repo.yaml  daq/sw/repository.data.xml
   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_custom_target(myrepository ALL
   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/daq/sw/myrepository.data.xml
)
----

The `create_repo.py` takes at least thee arguments: the name of your
software repository (MyRepo here), the name of the output file (the
generated oks file), and the input YAML file. Any additional file is
interpreted as existing OKS data or schema files to include into the
repository.

== Building another project against the TDAQ release

The instructions for doing this are almost identical to setting up a
work area. But instead of using the `tdaq_work_area()` macro you use
`tdaq_project` and specify the name of the project, its version number
(numerically in CMake style) and all dependent projects:

----
cmake_minimum_required(VERSION 3.14.0)
project(myproject VERSION 1.0.0)
find_package(TDAQ)
set(TDAQ_DB_PROJECT myproject)
tdaq_project(myproject 1.0.0 USES tdaq 8.3.1)
----

A thing you might want to change is the area into which OKS schema and
database files are installed. By default they go into
`installed/share/data/daq/[hw|sw|segments|schema|partitions]`. You can
change the `daq` component by setting the `TDAQ_DB_PROJECT` variable
*after* `find_package(TDAQ)` but *before* `tdaq_project()` as show
above.

You can add a top-level `cmake/` directory where various optional files
will be looked up:

* `cmake/myproject.cmake.in` This will be run through `configure_file()`
and the output will be copied to your install area. This typically
contains code that allows other projects that depend on yours to get all
necessary information about include and library directories. Look at the
TDAQ projects for examples.
* `cmake/template_noarch.spec.in` and `cmake/template_binary.spec.in`
are two template files that are used to customize the produced RPM
files. You might only need this if you follow the TDAQ style of having
one RPM per package, so probably not at all.
* If you have any project specific CMake modules that you would like to
make use of, put them into `cmake/modules`. They will be automatically
added to the `CMAKE_MODULE_PATH` as your project configures. Examples
are additional `FindXXX.cmake` modules, or project specific include
files etc. These modules are also automatically installed into
`installed/share/cmake/modules`. If you want downstream projects to make
use of them, have a line like this in your `myProjectConfig.cmake.in`
file:

----
list(APPEND CMAKE_MODULE_PATH ${PACKAGE_PREFIX}/share/cmake/modules)
----

If there are any templates you want downstream users to have available,
put them in `cmake/modules/templates`. They should end with `.in` and
will also be automatically installed.

For an example how a project area and a work area for that project might
look like, see https://gitlab.cern.ch/rhauser/ProjectExample

Finally, if you have a `cmake/last/` directory with a `CMakeLists.txt`
file, it will be added as the very last package. This means:

* It will be the last subdirectory processed after all other packages.
* It has not much meaning during the build, any targets might still
build in parallel or before other targets
* All `install()` commands executed here will be executed after all
other installation commands of the project.

== Release Building
:source-language: bash

This section is for the ATLAS TDAQ librarian or anybody else who wants
to build the releases from scratch.

The release build requires the following ingredients:

* Access to CVMFS for the LCG external software (or a local install from
the RPMS provided at http://lcgpackages.web.cern.ch/lcgpackages/rpms).
* The build scripts and supporting cmake modules from the
https://gitlab.cern.ch/atlas-tdaq-software/cmake_tdaq[cmake_tdaq] git
package. The package is public and can simply be cloned.
* The top level package for the project, typically names PROJECT-cmake
in the ATLAS TDAQ Gitlab group, e.g.
https://gitlab.cern.ch/atlas-tdaq-software/tdaq-common-cmake. For each
release there should be a corresponding branch in the git repository,
e.g. *`tdaq-common-01-44-00`*. The *`checkout_release`* script depends
on this.

=== Build scripts

The build scripts can be checked out wherever you want, and they are
completely relocatable. Note that you should use bash for all of the
following.

----
cd /some/work/area
git clone https://:@gitlab.cern.ch:8443/atlas-tdaq-software/cmake_tdaq.git
source cmake_tdaq/bin/setup.sh
----

=== Checkout and Build Locations

By default the build scripts hard-code some default locations for both
the checkout area and the build area. These are tailored for the
automated nightly builds. If you do a private build you most likely
won't have access to these areas. You can override them by setting two
environment variables:

----
export CHECKOUT_AREA=/work/releases
export BUILD_AREA=/tmp/build
----

There is another variable `CMAKE_PROJECT_PATH` the use of which is a bit
subtle. If you just want to build a single project, but use the standard
CVMFS installation area for projects you depend on, leave this variable
unchanged. E.g. `tdaq` would in this case use the `tdaq-common` project
from CVMFS.

If you want to build a whole project stack in a private area, set this
variable to the same location as `CHECKOUT_AREA`. In this case you
*must* start with the `tdaq-common` project or the other projects will
fail. Since this is a path variable, you can also give multiple paths
which will be searched in the order given.

==== Advanced Settings

Normally the LCG external software, as well as cmake itself and the
compilers are taken from CVMFS. The location is actually taken from
`LCG_RELEASE_BASE` if it is set.

It is possible to change this, and there is at least one use case:

* Use a private installation of LCG or CVMFS. For the latter set
`export LCG_RELEASE_BASE=/cvmfs/sft.cern.ch/lcg/releases`. All the other
tools are also taken from there.

The `nightly` branch of each TDAQ project always has the version number
`99.0.0`. For this branch of the `tdaq-common` project it is possible to
overwrite the LCG version to use from the cmake command line, by setting
`LCG_VERSION_CONFIG`:

----
# from the build area
cmake -DLCG_VERSION_CONFIG=LCG_95 -DBINARY_TAG=x86_64-el9-gcc13-opt ...
----

An LCG version number with 999 is interpreted in a special way. The
suffix will be interpreted as the path to the nightly LCG builds and
should be of the form `dev4/Tue`, so
`LCG_VERSION_CONFIG=LCG_999dev4/Tue`.

=== Checking out the release

You only need this command if you want to get the source code checked
out without building it. Otherwise the `build_release` script will do
any checkouts and updates that are necessary.

----
checkout_release tdaq-common tdaq-common-01-44-00
----

This will use the tag collector to checkout all relevant packages into
`$\{CHECKOUT_AREA}/tdaq-common/tdaq-common-01-44-00`.

Note that running this command when (maybe a previous version) of the
release is already checked out, it will update all the packages so that
their version corresponds to the one in the tag collector. If you want a
clean checkout, delete any existing prior files in that area.

The command uses default values for the tag collector directory
(`TAGCOLLECTOR`) and for `GITROOT`. If you export these variables before
using the command, you can change these values for the script.

With the recent submodule based versions, you can simply clone the whole
repository in one step. The only difference to `checkout_release` is
that the latter puts the result in a well-defined place, like this:

----
mkdir tdaq
git clone -b tdaq-99-00-00 --recurse-submodules https://:@gitlab.cern.ch:8443/atlas-tdaq-software/tdaq-cmake.git tdaq/tdaq-99-00-00
----

=== Building Patches

To build patches one needs only the top-level project directories of the
either `tdaq-cmake` or `tdaq-common-cmake`. It assumes you have done a
`cm_setup` before to determine the release to build against and the
build configuration.

----
cm_setup  tdaq-08-03-02 x86_64-el9-gcc13-opt
git clone -b tdaq-08-03-02 --recurse-submodules https://:@gitlab.cern.ch:8443/atlas-tdaq-software/tdaq-cmake.git
----

The `prepare_patches` script can build the RPMs for the currently setup
release/configuration. It should be executed from the top of the project
area.

----
cd tdaq-cmake
prepare_patches ipc is oh
----

This can be used in conjunction with the `diff_releases` script to
figure out which packages need a potential patch:

----
pkgs=$(diff_releases tdaq tdaq-08-03-01)
[ -n "${pkgs}" ] && prepare_patches ${pkgs}
----

An alternative is to got the `tdaq-cmake` project pipelines, run a new
pipeline by hand after setting the `PACKAGES` variable in the web
interface to a list of space separated package names. The RPMs will be
downloadable as an artifact after the build has finished.

=== Build the release

Note that this command will source the `cmake_tdaq/bin/setup.sh`
internally and do all the necessary check outs and updates according to
what is in the tag collector. You can therefore run this script with its
absolute path name which is the preferred way to do it since your
environment can interfere and override e.g. various search locations.

----
build_release tdaq-common tdaq-common-03-01-00 x86_64-el9-gcc13-opt
----

This will build the release in the
`$\{BUILD_AREA}/tdaq-common/tdaq-common-03-01-00/x86_64-el9-gcc13-opt`
directory.

The script will actually invoke `ctest` to build the release and run all
unit tests and install the release into
`$\{CHECKOUT_AREA}/tdaq-common/tdaq-common-03-01-00/installed`, and also
upload the results to
https://atlas-tdaq-sw.web.cern.ch/atlas-tdaq-sw/cdash

Any parameters passed after the mandatory arguments are passed to cmake.
Any arguments after `--` are passed to the ctest driver.

The following parameters can be passed at the end to modify the type of
release build that is done:

* -D CTEST_MODE=[Nightly|Continuous|Experimental] - default is
Experimental
* -D CTEST_TRACK=[dev4|Production] - for special builds
* -D CTEST_NOTESTS=1 - disable tests
* -D CTEST_NOCLEAN=1 - do not clean build directory (only use when you
know what you are doing).

This is the default behaviour. If you want to build the release by hand,
you can do it in whatever build directory you like, e.g.:

----
mkdir -p /tmp/build/mybuild
cd /tmp/build/mybuild
cmake_config x86_64-el9-gcc13-opt ${CHECKOUT_AREA}/tdaq-common/tdaq-common-03-01-00
make -j 8
make install/fast
make test
ctest -j 8
----

=== Build all TDAQ projects

The `build_stack` convenience script can be used to build a coherent
stack of TDAQ project. As for `checkout_release` you should set the
`CHECKOUT_AREA` and `BUILD_AREA` environment variables if the defaults
should not be used. The arguments to the script is a list of the three
TDAQ project versions followed by build configuration, e.g.:

----
export CHECKOUT_AREA=/tmp/source
export BUILD_AREA=/tmp/build
build_stack tdaq-common-99-00-00  tdaq-99-00-00 x86_64-el9-gcc13-opt
----

Additional arguments are passed to the cmake command line. By default
such a build will automatically submit its build results to the TDAQ
cdash board under the `Experimental` header. You can change the name of
your build by specifying `CTEST_BUILD_NAME` like this:

----
build_stack tdaq-common-99-00-00  tdaq-99-00-00 x86_64-el9-gcc13-opt -- -D CTEST_BUILD_NAME=MyBuild -D CTEST_MODE=Experimental
----

With recent versions you can set the versions of projects from the
command line. The way this works is that the source code corresponds to
the branches specified as the first arguments, but the internal version
number will be set via variables:

----
build_stack tdaq-common-99-00-00  tdaq-99-00-00 x86_64-el9-gcc13-opt -D TDAQ_COMMON_VERSION=4.0.0 -D TDAQ_VERSION=10.1.2
----

The script will adjust the installation paths such that they have the
usual form e.g. `tdaq/tdaq-10-01-02/installed`, all rooted at
$\{CHECKOUT_AREA}. The checked out code on the other hand will be at
`$\{CHECKOUT_AREA}/tdaq/tdaq-99-00-00/`.

=== Build RPMs

You can build the RPMs for the release by going to the appropriate build
directory and run

----
cpack
----

Both the `build_release` and `build_stack` scripts support an `--rpm`
option that will execute this step automatically.

----
build_stack --rpm tdaq-common-99-00-00  tdaq-99-00-00 x86_64-el9-gcc13-opt
----

=== Publishing the RPMs

Put the RPMs on any area that is accessible via the a web server, e.g.
`~/www/rpms`

----
cp *.rpm ~/www/rpms
cd ~/www/rpms
createrepo .
----

=== Installing the RPMs

----
# anywhere
git clone https://:@gitlab.cern.ch:8443/rhauser/ayum.git
source ayum/setup.sh
----

Now edit the `ayum/etc/yum.conf` file according to your needs,
especially the installation area. You can also run the
`./configure.ayum` command which will guide you through this process
with questions. Finally, you can use defaults for most values, by
calling `configure.ayum -D` when you are in the directory where you want
the software to be installed

----
mkdir /sw/atlas
cd /sw/atlas
/path/to/ayum/configure.ayum -D
ayum list tdaq-07-00-00*
----

If there is a local `ayum.conf` file, it will take priority over the one
in the `ayum` package itself.

If you want to access your private YUM repository that you created
above, add a file into `ayum/etc/yum.repos.d/` with such content as
follows, replacing the `baseurl` with the URL to your web server:

----
[myrepo]
name=my-tdaq-common
baseurl=http://rhauser.web.cern.ch/rhauser/rpm
enabled=1
----

Now you can execute the `ayum` command (which is just a modified yum) to
list and install the software as normal user into any location you like:

----
ayum list available
ayum list installed
ayum install tdaq-common-01-44-00_x86_64-el9-gcc13-opt
----

=== Installing the release on CVMFS

For this you need special privileges on the cvmfs server machine that
you probably don't have. It is meant as documentation for the TDAQ
librarian.

----
ssh cvmfs-atlas.cern.ch
sudo -i -u cvatlas
source tdaq/ayum/setup.sh

lock-install tdaq
cvmfs_server transaction atlas.cern.ch
cd /cvmfs/atlas.cern.ch/repo/sw/tdaq

#
# Change to the proper release version and binary configuration !
#
ayum install tdaq-08-01-00_x86_64-el9-gcc13-opt

# check installation in /cvmfs/atlas.cern.ch/repo/sw/tdaq

cvmfs-changelog --add "+<package name you installed>"
cvmfs_server publish atlas.cern.ch
unlock-install
----

In case you see errors during the installation with ayum you can abort
the transaction (don't forget to unlock-install ):

----
cvmfs_server abort atlas.cern.ch
unlock-install
----

=== Installing the nightlies on CVMFS

For nightlies a different CVMFS server is used
(cvmfs-atlas-online-nightlies.cern.ch).

----
ssh cvmfs-atlas-online-nightlies
sudo -i -u cvatlasonlinenightlies
----

The installation procedure is automated, manual intervention should be
only needed in case of problems.

* The build containers generate a tar.gz file of the `installed` area
and copy it via `xrdcp` to `/eos/user/a/atdaqeos/incoming/tar`
* An acron job deletes previous tar.gz files and moves the new ones to
`/eos/user/a/atdaqeos/www/nightlies/`. This is accessible via
`https://test-atdaq.web.cern.ch/test-atdaq/nightlies/----`.
* A cron job on the cvmfs server calls the `tdaq-install-nightlies.sh`
shell script which
** Tries to download a set of pre-defined tar files
** Checks if at least one full set of `tdaq-common` and `tdaq` builds
are available.
** Starts the cvmfs transaction and unpacks the tar files.
** Publishes the results

==== Possible Installation Problems

If the tar files couldn't be copied to EOS: Click the `Retry` button to
redo the build. The tar.gz files have to be copied by hand to the proper
location afterwards. The `tdaq-install-nightlies.sh` script should be
called with a list of the missing configurations, e.g.:

----
tdaq-install-nightlies.sh -t --add x86_64-el9-gcc13-opt
----

If the new files don't appear in the morning on the clients, and the
`cvmfs_swissknife` is still running: Kill the process by hand, then
simply run `cvmfs_server publish atlas-online-nightlies.cern.ch`. This
works in most cases. If it doesn't, abort the transaction with
`cvmfs_server abort  atlas-online-nightlies.cern.ch` and run
`tdaq-install-nightlies.sh -t` by hand. It should finish in about 10-12
minutes.

If it still does not work, run `cvmfs_server check`, and try
`tdaq-install-nightlies.sh` again. Open a ticket with IT support if no
success - there is a bug in cvmfs which is supposed to be fixed soon.

== Licensing

In the end every package developed by ATLAS that goes into a release
should be under the Apache 2.0 open source license. If you include
external code by copying/pasting it into your own package (to be avoided
if at all possible, since we can include foreign software packages as
externals), make sure their license is compatible with Apache 2.0, or
check back with software librarian and coordinator.

You should have a copy of the
https://www.apache.org/licenses/LICENSE-2.0.txt[Apache License file] in
the top level directory of your package. You can either adjust the
copyright notice at the very end of it, or add a separate `NOTICE` file
that should contain

----
Copyright  (C) 2001-2020 CERN for the benefit of the ATLAS collaboration.
----

Note that if you add the file via the gitlab template, it will put your
user name as copyright holder, so you have to modify it afterwards.

You should mention any external software that you have directly copied
into the package, if any, and their copyright and license. One line is
enough:

----
Exceptions:
    Package/File XYZ, Copyright Joe.Developer@company.com, MIT License.
----

You should acknowledge all current and past contributors to the package:

----
Contributors
=========
FirstName LastName <e-mail@provider.com>
----

If this is an old historical package, run this command for a first
approximation:

----
git log --format="%an <%ae>\n" | sort -u
----

You can (and probably should for new code) put a short license
identifier into one of the first lines of your code. The details depend
on the comment convention of the language. Furthermore, in some cases
you can't modify the first line, e.g. in case of scripts that use the
`#!/bin/interpreter` convention.

Here is how to do it for an existing code base, using C and C++

----
sed -i '1i/* SPDX-License-Identifier: Apache-2.0 */  */*.h* */*.c*
----

Similar for Java and Python, with their comment delimiters.
